// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from puma_motor_msgs:msg/Status.idl
// generated code does not contain a copyright notice

#ifndef PUMA_MOTOR_MSGS__MSG__DETAIL__STATUS__STRUCT_H_
#define PUMA_MOTOR_MSGS__MSG__DETAIL__STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MODE_VOLTAGE'.
/**
  * Available control modes, not all of which are broken out to
  * this ROS driver.
 */
enum
{
  puma_motor_msgs__msg__Status__MODE_VOLTAGE = 0
};

/// Constant 'MODE_CURRENT'.
enum
{
  puma_motor_msgs__msg__Status__MODE_CURRENT = 1
};

/// Constant 'MODE_SPEED'.
enum
{
  puma_motor_msgs__msg__Status__MODE_SPEED = 2
};

/// Constant 'MODE_POSITION'.
enum
{
  puma_motor_msgs__msg__Status__MODE_POSITION = 3
};

/// Constant 'MODE_VCOMP'.
enum
{
  puma_motor_msgs__msg__Status__MODE_VCOMP = 4
};

/// Constant 'FAULT_CURRENT'.
/**
  * Fault states which could cause the driver to be immobilized.
 */
enum
{
  puma_motor_msgs__msg__Status__FAULT_CURRENT = 1
};

/// Constant 'FAULT_TEMPERATURE'.
enum
{
  puma_motor_msgs__msg__Status__FAULT_TEMPERATURE = 2
};

/// Constant 'FAULT_BUS_VOLTAGE'.
enum
{
  puma_motor_msgs__msg__Status__FAULT_BUS_VOLTAGE = 4
};

/// Constant 'FAULT_BRIDGE_DRIVER'.
enum
{
  puma_motor_msgs__msg__Status__FAULT_BRIDGE_DRIVER = 8
};

// Include directives for member types
// Member 'device_name'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/Status in the package puma_motor_msgs.
/**
  * Number on the bus (CAN ID).
 */
typedef struct puma_motor_msgs__msg__Status
{
  uint8_t device_number;
  /// Name of joint controlled, or other identifier.
  rosidl_runtime_c__String device_name;
  /// Input terminal voltage (volts).
  float bus_voltage;
  /// Internal driver temperature (degC).
  float temperature;
  /// Voltage as output to the motor (volts).
  float output_voltage;
  /// Value of the auxiliary ADC (volts).
  float analog_input;
  uint8_t mode;
  uint8_t fault;
} puma_motor_msgs__msg__Status;

// Struct for a sequence of puma_motor_msgs__msg__Status.
typedef struct puma_motor_msgs__msg__Status__Sequence
{
  puma_motor_msgs__msg__Status * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} puma_motor_msgs__msg__Status__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PUMA_MOTOR_MSGS__MSG__DETAIL__STATUS__STRUCT_H_
